/* Package ATL
   Copyright K. Lano 2016-18 */ 

public abstract class Rule extends ModuleElement
{ Statement actionBlock = null; 
  OutPattern outPattern = null;
  // Matched rules must have an in pattern and out pattern, action block is optional. 
  // Called rules must have an out pattern or an action block, possibly both.  

  public Rule() 
  { outPattern = new OutPattern(); } 

  public void setActionBlock(Statement stat)
  { actionBlock = stat; } 

  public void setOutPattern(OutPattern outp)
  { if (outp != null) 
    { outPattern = outp; }
  }  
} 